VERSION 5.00
Begin VB.UserControl axPhoner 
   CanGetFocus     =   0   'False
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   InvisibleAtRuntime=   -1  'True
   Picture         =   "axPhoner.ctx":0000
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "axPhoner.ctx":014A
End
Attribute VB_Name = "axPhoner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Eigenschaftsvariablen:
Dim m_CalledMSN As String
Dim m_CallerNumber As String
Dim m_CallID As Long
Dim m_Status As String
Dim m_DialedCallID As Long
Dim m_WindowEnabled As Boolean
Dim m_NumberOfCalls As Long
Dim m_DisconnectReason As String
Dim m_Direction As String

'Ereignisdeklarationen:
Event OnRing(CallingNumber As String, CalledMSN As String, CallID As Long)
Event OnDial(CallingNumber As String, CalledMSN As String, CallStatus As String, CallID As Long)

'Neue Ereignisse
Event OnConnecting(CallingNumber As String, CalledMSN As String, CallID As Long)
Event OnConnected(CallingNumber As String, CalledMSN As String, CallID As Long)
Event OnOffering(CallingNumber As String, CalledMSN As String, CallID As Long)
Event OnDisconnected(CallingNumber As String, CalledMSN As String, CallID As Long)
Event OnDisconnecting(CallingNumber As String, CalledMSN As String, CallID As Long)
Event OnIdle(CallingNumber As String, CalledMSN As String, CallID As Long)

'Ereignisbehandlung
Public WithEvents myPhoner As CPhoner
Attribute myPhoner.VB_VarHelpID = -1


Private Sub myPhoner_OnChangeState(ByVal CallID As Long)
            'Phoner meldet ein Ereignis
    Dim Status As TCallState
    Dim Direction As TDirection
    Dim CallerID As String
    Dim CalledID As String
                        'Ereignis auswerten
    myPhoner.GetCallInfo CallID, Status, Direction, CallerID, CalledID
                        'Falls ein Ruf eingeht
    If Direction = Incoming Then
      m_Direction = "Incoming"
      m_CalledMSN = CalledID          'Angerufene MSN
      m_CallerNumber = CallerID       'Nummer des Anrufers
      m_CallID = CallID               'ID zum Anruf
                      'Ereignis auslsen
      RaiseEvent OnRing(CallerID, CalledID, CallID)
    Else              'Falls eine Nummer gewhlt wird
      m_Direction = "Outgoing"
      m_CalledMSN = CalledID          'verwendete MSN
      m_CallerNumber = CallerID       'angewhlte Nummer
      m_DialedCallID = CallID         'ID zum Anruf
      Select Case Status              'Status der Verbindung anzeigen
       Case Idle
          m_Status = "Idle"
          RaiseEvent OnIdle(CallerID, CalledID, CallID)
       Case Offering
          m_Status = "Offering"
          RaiseEvent OnOffering(CallerID, CalledID, CallID)
       Case Connecting
          m_Status = "Connecting"
          RaiseEvent OnConnecting(CallerID, CalledID, CallID)
       Case Connected
          m_Status = "Connected"
          RaiseEvent OnConnected(CallerID, CalledID, CallID)
       Case Disconnecting
          m_Status = "Disconnecting"
          RaiseEvent OnDisconnecting(CallerID, CalledID, CallID)
      Case Disconnected
          m_Status = "Disconnected"
          m_DisconnectReason = myPhoner.DisconnectReason(CallID)
          RaiseEvent OnDisconnected(CallerID, CalledID, CallID)
      End Select
                      'Ereignis auslsen aus Kompabilitt zu Vorversion
      RaiseEvent OnDial(CallerID, CalledID, m_Status, CallID)
    End If

End Sub

Private Sub UserControl_Initialize()
        'Instanz von Phoner holen
Set myPhoner = New CPhoner
End Sub

Public Property Get Direction() As String
                'Eingehender oder abgehender Ruf
    Direction = m_Direction
End Property

Public Property Get CalledMSN() As String
Attribute CalledMSN.VB_Description = "Enthlt die vom Anrufer gewhlte Nummer"
                'angerufene oder zum Anrufen verwendete MSN ausgeben
    CalledMSN = m_CalledMSN
End Property


Public Property Get CallerNumber() As String
Attribute CallerNumber.VB_Description = "Telefonnummer des Anrufers"
                'Nummer des Anrufers oder zum Whlen verwendete Nummer
    CallerNumber = m_CallerNumber
End Property

Public Property Get CallID() As Long
                'Die ID eines Phoner-Anrufes
    CallID = m_CallID
End Property

Public Property Get Status() As String
                'Statusmeldung zum ein- bzw. abgehenden Anruf
    Status = m_Status
End Property

Public Property Get NumberOfCalls() As Long
                'Anzahl der aktiven Anrufe
    m_NumberOfCalls = myPhoner.NumberOfCalls
    NumberOfCalls = m_NumberOfCalls
End Property

Public Property Get WindowEnabled() As Boolean
                'Soll Phoner-Fenster angezeigt werden ?
    m_WindowEnabled = myPhoner.WindowEnabled
    WindowEnabled = m_WindowEnabled
End Property

Public Property Let WindowEnabled(mVisible As Boolean)
                'Phoner Anruf-Fenster anzeigen oder nicht
    m_WindowEnabled = mVisible
    myPhoner.WindowEnabled = mVisible
End Property


Public Property Get DisconnectReason() As String
                'Grund fr letzte Verbindungstrennung
    DisconnectReason = m_DisconnectReason
End Property



Public Function CallNumber(strNumber As String, Optional strMSN As String) As Boolean
Attribute CallNumber.VB_Description = "Whlt die bergebene Nummer ber Phoner an"
                 'Eine Nummer Whlen. Optional kann noch eine MSN angegeben werden
                 'die die Rufnummerwahl veranlasst.
                 'Keine Prfung der zu whlenden Nummer. Dadurch sind nun auch
                 'Sonderzeichen wie * oder # mglich ;)
    CallNumber = True

    If IsMissing(strMSN) Then
        myPhoner.MakeCall (strNumber)
    Else
        myPhoner.MakeCallOver strNumber, strMSN
    End If
   
End Function


Public Function SendSMS(strNumber As String, strText As String) As Boolean
                'SMS oder TTS versenden
    SendSMS = False

    If strText <> "" Then
        SendSMS = True
        myPhoner.SendSMS strNumber, strText
    End If

End Function


Public Function SendDTMF(mCallID As Long, mDTMF As String) As Boolean
                'DTMF versenden
SendDTMF = False
If mDTMF <> "" Then
    SendDTMF = True
    myPhoner.SendDTMF mCallID, mDTMF
End If
End Function

Public Function HangUpNumber() As Boolean
                'letzten Anruf beenden (nur aus Kompabilitt zur Version 1 vorhanden
                'knftig besser Disconnect-Function verwenden)
    myPhoner.DisconnectCall (m_DialedCallID)
    HangUpNumber = True
End Function
Public Function AnswerCall(mCallID As Long) As Boolean
    myPhoner.AnswerCall (mCallID)
    AnswerCall = True
End Function

Public Function Disconnect(m_DialedCallID) As String
            'Beendet Anruf und gibt Grund fr Abbruch als String zurck
    myPhoner.DisconnectCall (m_DialedCallID)
    Disconnect = myPhoner.DisconnectReason(m_DialedCallID)
End Function


Public Function PhoneConvert(m_TelStr As String) As String
Dim S As String
    S = m_TelStr
            'Entfernt () und Spaces aus einer Telefonnummer
    S = Replace(S, "(", "")
    S = Replace(S, ")", "")
    S = Replace(S, " ", "")
    PhoneConvert = S
End Function
